security:
    encoders:
        App\Entity\User:
            algorithm: auto

    # https://symfony.com/doc/current/security.html#where-do-users-come-from-user-providers
    providers:
        # used to reload user from session & other features (e.g. switch_user)
        app_user_provider:
            entity:
                class: App\Entity\User
                property: email
    firewalls:
        dev:
            pattern: ^/(_(profiler|wdt)|css|images|js)/
            security: false
        main:
            anonymous: lazy
            provider: app_user_provider
            guard:
                authenticators:
                    - App\Security\AppAuthenticator
            logout:
                path: app_logout
                # where to redirect after logout
                # target: app_any_route

            # activate different ways to authenticate
            # https://symfony.com/doc/current/security.html#firewalls-authentication

            # https://symfony.com/doc/current/security/impersonating_user.html
            # switch_user: true

    # Easy way to control access for large sections of your site
    # Note: Only the *first* access control that matches will be used
    access_control:
        - { path: ^/admin, roles: ROLE_ADMIN }
        - { path: ^/profil, roles: ROLE_USER }
        - { path: ^/profil/inscription, roles: IS_AUTHENTICATED_ANONYMOUSLY }
        # Accès refusé à la page ajout bon plan si on n'est pas un user
        - { path: ^/ajout, roles: ROLE_USER }
        #Accès refusé à la page de discussion si on n'est pas un user
        - { path: ^/chat, roles: ROLE_USER }
        - { path: ^/post/chat, roles: ROLE_USER }
        - { path: ^/post/ajout, roles: ROLE_USER }

